import { ITraining } from './src/training/types'

const data: { trainings: ITraining[]; polls: any } = {
  trainings: [
    {
      id: 'training0',
      title: 'Corona 1',
      type: {
        id: 'type0',
        name: 'HIIT',
        description: 'High Intensity Interval Training'
      },
      createdAt: '2020-03-25T21:13:43.284Z',
      trainingDate: '2020-03-31T09:45:00.000Z',
      location: 'At home',
      registrations: [],
      attendance: 0,
      ratings: [],
      published: true,
      blocks: [
        {
          id: 'block0',
          sequence: 0,
          title: 'Drop Sets',
          repetitions: 1,
          rest: 25,
          format: {
            id: 'format0',
            name: 'Sequence',
            description: 'Sequence of exercises'
          },
          blocks: [
            {
              id: 'block1',
              sequence: 0,
              title: 'Lateral move with jumps',
              repetitions: 1,
              format: {
                id: 'format0',
                name: 'Drop Sets',
                description:
                  'During the exercise, the moves get easier. Keep the heart rate up by increasing the intensity!'
              },
              rest: 25,
              blocks: [
                {
                  id: 'block2',
                  duration: 40,
                  video: '/media/block1-1.mp4',
                  description:
                    '4 lateral high knee steps, drop squat, a jump and a butt kick',
                  exercises: [
                    {
                      id: 'exercise0',
                      name: 'Lateral high knee run',
                      repetitions: 4,
                      description:
                        'Jog pulling your knees up high while moving sideways',
                      videos: ['https://www.youtube.com/watch?v=s5GanRixp6I'],
                      pictures: [
                        'https://media1.popsugar-assets.com/files/thumbor/xfgCQbEWOZpPDA_HTMSfgcOnYYE/fit-in/1024x1024/filters:format_auto-!!-:strip_icc-!!-/2015/06/26/981/n/1922729/a7719ba19ea7a1ae_lateral-run-and-hold/i/Tabata-One-Lateral-High-Knee-Run-Hold.jpg'
                      ],
                      targets: [],
                      baseExercise: {
                        id: 'baseExercise1',
                        name: 'Jog on the spot'
                      }
                    },
                    {
                      id: 'exercise1',
                      name: 'Squat',
                      repetitions: 1,
                      description:
                        'Sit down backwards, hip about knee-high. Keep your knees behind the toes.',
                      videos: [],
                      pictures: [],
                      targets: ['Thighs', 'Glutes'],
                      baseExercise: {
                        id: 'baseExercise1',
                        name: 'Squat'
                      }
                    },
                    {
                      id: 'exercise2',
                      name: 'Block jump',
                      repetitions: 1,
                      description:
                        'Jump up. Feet are at least hip-wide, land in a squat. Use your arms to add momentum.',
                      videos: [],
                      pictures: [],
                      targets: ['Thighs', 'Glutes'],
                      baseExercise: {
                        id: 'baseExercise1',
                        name: 'Jump'
                      }
                    },
                    {
                      id: 'exercise3',
                      name: 'Butt kick',
                      repetitions: 1,
                      description:
                        'Jump up. While jumping, try to kick your butt with your heels.',
                      videos: [],
                      pictures: [],
                      targets: [],
                      baseExercise: {
                        id: 'baseExercise1',
                        name: 'Jump'
                      }
                    }
                  ]
                },
                {
                  id: 'block3',
                  duration: 30,
                  video: '/media/block1-2.mp4',
                  description: 'Drop squat, a jump and a butt kick.',
                  exercises: [
                    {
                      id: 'exercise1',
                      name: 'Squat',
                      repetitions: 1,
                      description:
                        'Sit down backwards, hip about knee-high. Keep your knees behind the toes.',
                      videos: [],
                      pictures: [],
                      targets: ['Thighs', 'Glutes'],
                      baseExercise: {
                        id: 'baseExercise1',
                        name: 'Squat'
                      }
                    },
                    {
                      id: 'exercise2',
                      name: 'Block jump',
                      repetitions: 1,
                      description:
                        'Jump up. Feet are at least hip-wide, land in a squat. Use your arms to add momentum.',
                      videos: [],
                      pictures: [],
                      targets: ['Thighs', 'Glutes'],
                      baseExercise: {
                        id: 'baseExercise1',
                        name: 'Jump'
                      }
                    },
                    {
                      id: 'exercise3',
                      name: 'Butt kick',
                      repetitions: 1,
                      description:
                        'Jump up. While jumping, try to kick your butt with your heels.',
                      videos: [],
                      pictures: [],
                      targets: [],
                      baseExercise: {
                        id: 'baseExercise1',
                        name: 'Jump'
                      }
                    }
                  ]
                },
                {
                  id: 'block4',
                  duration: 20,
                  video: '/media/block1-3.mp4',
                  description: 'Drop squat and a jump.',
                  exercises: [
                    {
                      id: 'exercise1',
                      name: 'Squat',
                      repetitions: 1,
                      description:
                        'Sit down backwards, hip about knee-high. Keep your knees behind the toes.',
                      videos: [],
                      pictures: [],
                      targets: ['Thighs', 'Glutes'],
                      baseExercise: {
                        id: 'baseExercise1',
                        name: 'Squat'
                      }
                    },
                    {
                      id: 'exercise2',
                      name: 'Block jump',
                      repetitions: 1,
                      description:
                        'Jump up. Feet are at least hip-wide, land in a squat. Use your arms to add momentum.',
                      videos: [],
                      pictures: [],
                      targets: ['Thighs', 'Glutes'],
                      baseExercise: {
                        id: 'baseExercise1',
                        name: 'Jump'
                      }
                    }
                  ]
                }
              ]
            },
            {
              id: 'block5',
              sequence: 0,
              title: 'Pushup with frog-jump and block jump',
              repetitions: 1,
              format: {
                id: 'format0',
                name: 'Drop Sets',
                description:
                  'During the exercise, the moves get easier. Keep the heart rate up by increasing the intensity!'
              },
              rest: 25,
              blocks: [
                {
                  id: 'block6',
                  duration: 40,
                  video: '/media/block2-1.mp4',
                  description: 'Pushup, frog jump and a jump.',
                  exercises: [
                    {
                      id: 'exercise1',
                      name: 'Squat',
                      repetitions: 1,
                      description:
                        'Sit down backwards, hip about knee-high. Keep your knees behind the toes.',
                      videos: [],
                      pictures: [],
                      targets: ['Thighs', 'Glutes'],
                      baseExercise: {
                        id: 'baseExercise1',
                        name: 'Squat'
                      }
                    },
                    {
                      id: 'exercise4',
                      name: 'Pushup',
                      repetitions: 1,
                      description: '',
                      videos: [],
                      pictures: [],
                      targets: ['Chest', 'Triceps'],
                      baseExercise: {
                        id: 'baseExercise1',
                        name: 'Pushup'
                      }
                    },
                    {
                      id: 'exercise2',
                      name: 'Frog jump',
                      repetitions: 1,
                      description: '',
                      videos: [],
                      pictures: [],
                      targets: ['Core', 'Quads'],
                      baseExercise: {
                        id: 'baseExercise1',
                        name: 'Mountain climber'
                      }
                    },
                    {
                      id: 'exercise2',
                      name: 'Block jump',
                      repetitions: 1,
                      description: '',
                      videos: [],
                      pictures: [],
                      targets: [],
                      baseExercise: {
                        id: 'baseExercise1',
                        name: 'Jump'
                      }
                    }
                  ]
                },
                {
                  id: 'block7',
                  duration: 30,
                  video: '/media/block2-2.mp4',
                  description: 'Pushup and a jump',
                  exercises: [
                    {
                      id: 'exercise1',
                      name: 'Squat',
                      repetitions: 1,
                      description:
                        'Sit down backwards, hip about knee-high. Keep your knees behind the toes.',
                      videos: [],
                      pictures: [],
                      targets: ['Thighs', 'Glutes'],
                      baseExercise: {
                        id: 'baseExercise1',
                        name: 'Squat'
                      }
                    },
                    {
                      id: 'exercise4',
                      name: 'Pushup',
                      repetitions: 1,
                      description: '',
                      videos: [],
                      pictures: [],
                      targets: ['Chest', 'Triceps'],
                      baseExercise: {
                        id: 'baseExercise1',
                        name: 'Pushup'
                      }
                    },
                    {
                      id: 'exercise2',
                      name: 'Block jump',
                      repetitions: 1,
                      description: '',
                      videos: [],
                      pictures: [],
                      targets: [],
                      baseExercise: {
                        id: 'baseExercise1',
                        name: 'Jump'
                      }
                    }
                  ]
                },
                {
                  id: 'block8',
                  duration: 20,
                  video: '/media/burpee.mp4',
                  description: 'Just a burpee.',
                  exercises: [
                    {
                      id: 'exercise1',
                      name: 'Squat',
                      repetitions: 1,
                      description:
                        'Sit down backwards, hip about knee-high. Keep your knees behind the toes.',
                      videos: [],
                      pictures: [],
                      targets: ['Thighs', 'Glutes'],
                      baseExercise: {
                        id: 'baseExercise1',
                        name: 'Squat'
                      }
                    },
                    {
                      id: 'exercise2',
                      name: 'Block jump',
                      repetitions: 1,
                      description: '',
                      videos: [],
                      pictures: [],
                      targets: [],
                      baseExercise: {
                        id: 'baseExercise1',
                        name: 'Jump'
                      }
                    }
                  ]
                }
              ]
            }
          ]
        },

        {
          id: 'block9',
          sequence: 0,
          title: 'Power Sets with Kicker',
          repetitions: 2,
          format: {
            id: 'format0',
            name: 'Sequence',
            description: 'Sequence of exercises'
          },
          rest: 25,
          blocks: [
            {
              id: 'block10',
              sequence: 0,
              title: 'Block A',
              repetitions: 1,
              format: {
                id: 'format0',
                name: 'Power Set',
                description:
                  'Sequence of exercises targeting different regions without rest in between.'
              },
              rest: 25,
              blocks: [
                {
                  id: 'block11',
                  duration: 25,
                  video: '/media/block3-1.mp4',
                  description: '',
                  exercises: [
                    {
                      id: 'exercise6',
                      name: 'Donkey kick',
                      repetitions: 1,
                      description: '',
                      videos: [],
                      pictures: [],
                      targets: [],
                      baseExercise: {
                        id: 'baseExercise1',
                        name: 'Mountain climber'
                      }
                    },
                    {
                      id: 'exercise1',
                      name: 'Plank walk',
                      repetitions: 2,
                      description: '',
                      videos: [],
                      pictures: [],
                      targets: [],
                      baseExercise: {
                        id: 'baseExercise1',
                        name: 'Plank'
                      }
                    }
                  ]
                },
                {
                  id: 'block12',
                  duration: 25,
                  video: '/media/block3-2.mp4',
                  exercises: [
                    {
                      id: 'exercise1',
                      name: 'Long jump',
                      repetitions: 1,
                      description: '',
                      videos: [],
                      pictures: [],
                      targets: [],
                      baseExercise: {
                        id: 'baseExercise1',
                        name: 'Jump'
                      }
                    },
                    {
                      id: 'exercise2',
                      name: '180°',
                      repetitions: 1,
                      description: '',
                      videos: [],
                      pictures: [],
                      targets: [],
                      baseExercise: {
                        id: 'baseExercise1',
                        name: 'Jump'
                      }
                    }
                  ]
                },
                {
                  id: 'block13',
                  duration: 10,
                  video: '/media/burpee.mp4',
                  exercises: [
                    {
                      id: 'exercise1',
                      name: 'Burpee',
                      repetitions: 1,
                      description: '',
                      videos: [],
                      pictures: [],
                      targets: [],
                      baseExercise: {
                        id: 'baseExercise1',
                        name: 'Burpee'
                      }
                    }
                  ]
                }
              ]
            },

            {
              id: 'block14',
              sequence: 0,
              title: 'Block B',
              repetitions: 1,
              format: {
                id: 'format0',
                name: 'Power Set',
                description:
                  'Sequence of exercises targeting different regions without rest in between.'
              },
              rest: 25,
              blocks: [
                {
                  id: 'block15',
                  duration: 25,
                  video: '/media/block4-1.mp4',
                  exercises: [
                    {
                      id: 'exercise6',
                      name: 'Side climber',
                      repetitions: 2,
                      description: '',
                      videos: [],
                      pictures: [],
                      targets: [],
                      baseExercise: {
                        id: 'baseExercise1',
                        name: 'Mountain climber'
                      }
                    },
                    {
                      id: 'exercise1',
                      name: 'Pushup',
                      repetitions: 1,
                      description: '',
                      videos: [],
                      pictures: [],
                      targets: [],
                      baseExercise: {
                        id: 'baseExercise1',
                        name: 'Plank'
                      }
                    }
                  ]
                },
                {
                  id: 'block16',
                  duration: 25,
                  video: '/media/block4-2.mp4',
                  exercises: [
                    {
                      id: 'exercise1',
                      name: 'Power lunge',
                      repetitions: 1,
                      description: '',
                      videos: [],
                      pictures: [],
                      targets: [],
                      baseExercise: {
                        id: 'baseExercise1',
                        name: 'Lunge'
                      }
                    }
                  ]
                },
                {
                  id: 'block17',
                  duration: 20,
                  video: '/media/burpee.mp4',
                  exercises: [
                    {
                      id: 'exercise1',
                      name: 'Burpee',
                      repetitions: 1,
                      description: '',
                      videos: [],
                      pictures: [],
                      targets: [],
                      baseExercise: {
                        id: 'baseExercise1',
                        name: 'Burpee'
                      }
                    }
                  ]
                }
              ]
            },

            {
              id: 'block18',
              sequence: 0,
              title: 'Block C',
              repetitions: 1,
              format: {
                id: 'format0',
                name: 'Power Set',
                description:
                  'Sequence of exercises targeting different regions without rest in between.'
              },
              rest: 25,
              blocks: [
                {
                  id: 'block19',
                  duration: 25,
                  video: '/media/block5-1.mp4',
                  exercises: [
                    {
                      id: 'exercise6',
                      name: 'Inch worm',
                      repetitions: 1,
                      description: '',
                      videos: [],
                      pictures: [],
                      targets: [],
                      baseExercise: {
                        id: 'baseExercise1',
                        name: 'Plank'
                      }
                    },
                    {
                      id: 'exercise1',
                      name: 'Block jump',
                      repetitions: 1,
                      description: '',
                      videos: [],
                      pictures: [],
                      targets: [],
                      baseExercise: {
                        id: 'baseExercise1',
                        name: 'Jump'
                      }
                    }
                  ]
                },
                {
                  id: 'block20',
                  duration: 25,
                  video: '/media/fastfeet.mp4',
                  exercises: [
                    {
                      id: 'exercise1',
                      name: 'Fast feet',
                      repetitions: 1,
                      description: '',
                      videos: [],
                      pictures: [],
                      targets: [],
                      baseExercise: {
                        id: 'baseExercise1',
                        name: 'Jog on the spot'
                      }
                    }
                  ]
                },
                {
                  id: 'block1',
                  duration: 30,
                  video: '/media/burpee.mp4',
                  exercises: [
                    {
                      id: 'exercise1',
                      name: 'Burpee',
                      repetitions: 1,
                      description: '',
                      videos: [],
                      pictures: [],
                      targets: [],
                      baseExercise: {
                        id: 'baseExercise1',
                        name: 'Burpee'
                      }
                    }
                  ]
                }
              ]
            }
          ]
        },

        {
          id: 'block25',
          sequence: 0,
          title: 'Leg AMRAP',
          repetitions: 3,
          format: {
            id: 'format0',
            name: 'AMRAP',
            description: 'As many rounds as possible'
          },
          rest: 25,
          blocks: [
            {
              id: 'block0',
              duration: 90,
              video: '/media/block6-1.mp4',
              description:
                'Try to finish as many rounds as possible in 90 seconds! In the second round, finish the same number of rounds, but add the challenge (bear crawl) after each round. In the third round, finish the same number of rounds again, but add the challenge after every exercise. The target is 3 rounds.',
              exercises: [
                {
                  id: 'exercise6',
                  name: 'Leap/Jump',
                  repetitions: 5,
                  description: '',
                  videos: [],
                  pictures: [],
                  targets: [],
                  baseExercise: {
                    id: 'baseExercise1',
                    name: 'Mountain climber'
                  }
                },
                {
                  id: 'exercise1',
                  name: 'Low 180',
                  repetitions: 10,
                  description: '',
                  videos: [],
                  pictures: [],
                  targets: [],
                  baseExercise: {
                    id: 'baseExercise1',
                    name: 'Plank'
                  }
                },
                {
                  id: 'exercise1',
                  name: 'Ice skater',
                  repetitions: 15,
                  description: '',
                  videos: [],
                  pictures: [],
                  targets: [],
                  baseExercise: {
                    id: 'baseExercise1',
                    name: 'Plank'
                  }
                },
                {
                  id: 'exercise1',
                  name: 'Bear crawl',
                  repetitions: 1,
                  description: '',
                  videos: [],
                  pictures: [],
                  targets: [],
                  baseExercise: {
                    id: 'baseExercise1',
                    name: 'Plank'
                  }
                }
              ]
            }
          ]
        },

        {
          id: 'block3',
          sequence: 0,
          title: '1 Minute Challenges',
          repetitions: 1,
          format: {
            id: 'format0',
            name: 'Sequence',
            description: 'Sequence of exercises'
          },
          rest: 25,
          blocks: [
            {
              id: 'block0',
              duration: 60,
              rest: 25,
              video: '/media/block7-1.mp4',
              description:
                'Go fast on the dynamic exercise, and hold still on the static part, moving as little as possible!',
              exercises: [
                {
                  id: 'exercise6',
                  name: 'Single arm burpee',
                  repetitions: 8,
                  description: '',
                  videos: [],
                  pictures: [],
                  targets: [],
                  baseExercise: {
                    id: 'baseExercise1',
                    name: 'Mountain climber'
                  }
                },
                {
                  id: 'exercise1',
                  name: 'Single arm plank + Foot lift L/R',
                  repetitions: 8,
                  description: '',
                  videos: [],
                  pictures: [],
                  targets: [],
                  baseExercise: {
                    id: 'baseExercise1',
                    name: 'Plank'
                  }
                }
              ]
            },

            {
              id: 'block0',
              duration: 60,
              rest: 25,
              video: '/media/block8-1.mp4',
              description:
                'Go fast on the dynamic exercise, and hold still on the static part, moving as little as possible!',
              exercises: [
                {
                  id: 'exercise6',
                  name: 'Rotation drop squat + Jack',
                  repetitions: 8,
                  description: '',
                  videos: [],
                  pictures: [],
                  targets: [],
                  baseExercise: {
                    id: 'baseExercise1',
                    name: 'Mountain climber'
                  }
                },
                {
                  id: 'exercise1',
                  name: 'Hold squat + Step out L/R',
                  repetitions: 8,
                  description: '',
                  videos: [],
                  pictures: [],
                  targets: [],
                  baseExercise: {
                    id: 'baseExercise1',
                    name: 'Plank'
                  }
                }
              ]
            }
          ]
        },

        {
          id: 'block2',
          sequence: 0,
          title: 'Core AMRAP',
          repetitions: 1,
          format: {
            id: 'format0',
            name: 'AMRAP',
            description: 'As many rounds as possible'
          },
          rest: 25,
          blocks: [
            {
              id: 'block0',
              duration: 90,
              video: '/media/block9-1.mp4',
              description:
                'Try to finish as many rounds as possible in 90 seconds! Keep the transitions short. The target is 3 rounds.',
              exercises: [
                {
                  id: 'exercise6',
                  name: 'C-Crunch',
                  repetitions: 10,
                  description: '',
                  videos: [],
                  pictures: [],
                  targets: [],
                  baseExercise: {
                    id: 'baseExercise1',
                    name: 'Mountain climber'
                  }
                },
                {
                  id: 'exercise1',
                  name: 'Bicycle crunch',
                  repetitions: 10,
                  description: '',
                  videos: [],
                  pictures: [],
                  targets: [],
                  baseExercise: {
                    id: 'baseExercise1',
                    name: 'Plank'
                  }
                },
                {
                  id: 'exercise1',
                  name: 'Mountain climber',
                  repetitions: 10,
                  description: '',
                  videos: [],
                  pictures: [],
                  targets: [],
                  baseExercise: {
                    id: 'baseExercise1',
                    name: 'Plank'
                  }
                }
              ]
            }
          ]
        }
      ]
    }
  ],
  polls: []
}

export default data
